/*   Piskvorky 1.2 for Windows  (C)opyright Martin Kuzela KUKISOFT 1995

                       FREEWARE
*/                                     
#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>

//constants in the plan:
#define X 120
#define O 111

typedef struct {int x,y;} posit;//returning structure
typedef struct {int x,y,t1,t2;} rec;//structure of game record

void DrawX(int ax,int ay,HPEN hx);
void DrawO(int ax,int ay,HPEN hx);
/*long FAR PASCAL KalkulProc(HWND hWnd,WORD msg,WORD wParam,LONG lParam);
BOOL CALLBACK DProc(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam);
BOOL CALLBACK D2Proc(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam);
*/
//functions of players:
extern posit halabala(int xox,int yoy,unsigned char ja);
extern posit kuko(int xox,int yoy,unsigned char ja);
extern posit rkovac(int xox,int yoy,unsigned char ja1);
extern posit bartovic(int xox,int yoy,unsigned char ja);

//(de)initializing functions:
extern int *n;
extern void initbartovic(void);
//extern posit ikovac(int riad,int stlp,unsigned char ja2);

unsigned char a[50][50];//the main plan of game
int NP;//size of plan is NPxNP
rec *rcd;//pointer to record of game (0...indx-1)
int indx=0;//pointer to first free position (used by moving in game record)
int lastrec=0;//pointer to first free position (of all game)
int play1=120,play2=133;//identifiers of players
int WhoMoves=1;//which player is on the move
int PlayNow=0;//which player moves now (=-2 nobody)
int wxx; //width of one rectangle in pixels
int wxy; //height of one rectangle in pixels
int wx; //width of plan (not window) in pixels
int wy; //height of plan (not window) in pixels
int key_x,key_y;
BOOL wire;//,bblt,onlylast,
BOOL onlywire=FALSE;
DWORD time1,time2;

//Some windows related data
WNDCLASS wndClass;
HANDLE hInst;
HWND hDlg=NULL,hWnd;
HDC mHDC;
HPEN hold,hwire,hcervene,hmodre,hcierne,hbiele;
OPENFILENAME ofn;
HMENU hm;
FILE *file1; 
PAINTSTRUCT ps;
HWND hwndDlg;
DLGPROC dlgprc;
RECT rv;
TIMERPROC lpfnMyTimerProc;

//strings
char sss[60],szFile[256], szFileTitle[50];
char sss2[30];

//indexes,helping int
int cx,cy,qq1,qq2,kx1,kx2,ko1,ko2;
int wxx3,wxy3,wxx6,wxy6,wxx12,wxy12;
BOOL pi1,pi2,isplay;
posit hint={-1};

unsigned char za3(int px,int py)
{ if ((px<0)||(px>=NP)||(py<0)||(py>=NP)) return 0; else return a[px][py];}

// End of game?
BOOL ques(int s1,int s2,char cv)
{ int p1,p3;
  p1=0;
  for(p3=0;p3<5;p3++) if (za3(s1+p3,s2)==cv) p1++; else break;
  for(p3=1;p3<5;p3++) if (za3(s1-p3,s2)==cv) p1++; else break;
  if (p1>4) return TRUE;
  p1=0;
  for(p3=0;p3<5;p3++) if (za3(s1,s2+p3)==cv) p1++; else break;
  for(p3=1;p3<5;p3++) if (za3(s1,s2-p3)==cv) p1++; else break;
  if (p1>4) return TRUE;
  p1=0;
  for(p3=0;p3<5;p3++) if (za3(s1+p3,s2+p3)==cv) p1++; else break;
  for(p3=1;p3<5;p3++) if (za3(s1-p3,s2-p3)==cv) p1++; else break;
  if (p1>4) return TRUE;
  p1=0;
  for(p3=0;p3<5;p3++) if (za3(s1-p3,s2+p3)==cv) p1++; else break;
  for(p3=1;p3<5;p3++) if (za3(s1+p3,s2-p3)==cv) p1++; else break;
  if (p1>4) return TRUE;
  return FALSE;
}

void setbar(BOOL debg)
{if (debg) lstrcpy(sss,"DEBUG MODE ");
      else lstrcpy(sss,"Piskvorky 1.2fW ");
 GetMenuString(hm,play1,sss2,30,MF_BYCOMMAND);
 lstrcat(sss,sss2);
 lstrcat(sss," & ");
 GetMenuString(hm,play2,sss2,30,MF_BYCOMMAND);
 //cas=GetTickCount();
 lstrcat(sss,sss2);
 SetWindowText(hWnd,sss);
}

void quitdebugmod(void)
{PlayNow=(WhoMoves)?play1-120:play2-130;
 setbar(FALSE);
 EnableMenuItem(hm,2,MF_GRAYED);
 EnableMenuItem(hm,4,MF_GRAYED);
 EnableMenuItem(hm,5,MF_GRAYED);
 EnableMenuItem(hm,3,MF_GRAYED);
 DrawMenuBar(hWnd);
 SendMessage(hWnd,WM_KEYDOWN,0,0);
}

void debugmod(void)
{PlayNow=-2;
 EnableMenuItem(hm,2,MF_ENABLED);
 EnableMenuItem(hm,4,MF_ENABLED);
 EnableMenuItem(hm,5,MF_ENABLED);
 EnableMenuItem(hm,3,MF_ENABLED);
 for (cx=120;cx<140;cx++) CheckMenuItem(hm,cx,MF_UNCHECKED);
 CheckMenuItem(hm,play1,MF_CHECKED);
 CheckMenuItem(hm,play2,MF_CHECKED);
 DrawMenuBar(hWnd);
 setbar(TRUE);
}

void NGame(void)
{memset(a,0,50*50);
 InvalidateRect(hWnd,NULL,TRUE);
 indx=lastrec=0;
 WhoMoves=1;
 wx=NP*wxx;
 wy=NP*wxy;
 key_x=key_y=NP/2;
 quitdebugmod();
 initbartovic();
}

void saywin(unsigned char bol)
{debugmod();
 lstrcpy(sss,"Player ");
 GetMenuString(hm,(bol==X)?play1:play2,sss2,30,MF_BYCOMMAND);
 lstrcat(sss,sss2);
 if (bol==X) lstrcat(sss," (X) won"); else lstrcat(sss," (O) won");
 if (MessageBox(hWnd,"\n Start a new game?",sss,MB_YESNO|MB_ICONSTOP)==IDYES) NGame();
}

void saydraw(void)
{debugmod();
 if (MessageBox(hWnd,"No one can win\n\n Start a new game?","DRAW GAME",MB_YESNO|MB_ICONSTOP)==IDYES) NGame();
}

void sayerr(void)
{debugmod();
 MessageBox(hWnd,"Error ->Invalid move\nRestart aplication please","!?!?!?!?",MB_ICONSTOP);
}

void TheEnd(void)
{free(n);
 free(rcd);
 KillTimer(hWnd,1);
 FreeProcInstance(lpfnMyTimerProc);
 GetWindowRect(hWnd,&rv);
 itoa(NP,sss,10);
 WritePrivateProfileString("Size","NP",sss,"piskvork.ini");
 itoa(wxx,sss,10);
 WritePrivateProfileString("Size","wxx",sss,"piskvork.ini");
 itoa(wxy,sss,10);
 WritePrivateProfileString("Size","wxy",sss,"piskvork.ini");
 itoa(rv.left,sss,10);
 WritePrivateProfileString("Size","left",sss,"piskvork.ini");
 itoa(rv.top,sss,10);
 WritePrivateProfileString("Size","top",sss,"piskvork.ini");
 itoa(rv.right-rv.left,sss,10);
 WritePrivateProfileString("Size","width",sss,"piskvork.ini");
 itoa(rv.bottom-rv.top,sss,10);
 WritePrivateProfileString("Size","height",sss,"piskvork.ini");

 itoa(wire,sss,10);
 WritePrivateProfileString("Options","wire",sss,"piskvork.ini");
// itoa(bblt,sss,10);
// WritePrivateProfileString("Options","bblt",sss,"piskvork.ini");
 WinHelp(hWnd,"pisk.hlp",HELP_QUIT,0);
 PostQuitMessage(0);
}

void InvPis(char ifblack)
{if (!indx) return;
 mHDC=GetDC(hWnd);
 hwire=CreatePen(PS_SOLID,1,RGB(100,200,200));
 hbiele=CreatePen(PS_SOLID,(wxx+wxy)/24,RGB(255,255,255));
 hcierne=CreatePen(PS_SOLID,(wxx+wxy)/12,RGB(0,0,0));
 hcervene=CreatePen(PS_SOLID,(wxx+wxy)/12,RGB(255,0,0));
 hmodre=CreatePen(PS_SOLID,(wxx+wxy)/12,RGB(0,0,255));
 hold=SelectObject(mHDC,hmodre);
 if (indx%2) DrawX(rcd[indx-1].x,rcd[indx-1].y,(ifblack)?hcierne:hmodre);
        else DrawO(rcd[indx-1].x,rcd[indx-1].y,(ifblack)?hcierne:hcervene);
 SelectObject(mHDC,hold);
 DeleteObject(hmodre);
 DeleteObject(hcervene);
 DeleteObject(hcierne);
 DeleteObject(hbiele);
 DeleteObject(hwire);

 ReleaseDC(hWnd,mHDC);
/*rv.left=rcd[indx-1].x*wxx;
   rv.right=(rcd[indx-1].x+1)*wxx;
   rv.top=rcd[indx-1].y*wxy;
   rv.bottom=(rcd[indx-1].y+1)*wxy;
   InvalidateRect(hWnd,&rv,TRUE);*/
}

void Inv(void)
{if (!indx) return;
 mHDC=GetDC(hWnd);
 //hold=
 SelectObject(mHDC,GetStockObject(DKGRAY_BRUSH));
 //SelectObject(mHDC,hold);
 Rectangle(mHDC,rcd[indx-1].x*wxx,rcd[indx-1].y*wxy,(rcd[indx-1].x+1)*wxx,(rcd[indx-1].y+1)*wxy);

 ReleaseDC(hWnd,mHDC);
}

BOOL drawgame(void)
{int canx,cano,can2x,can2o,can3x,can3o,can4x,can4o;
 for(qq1=0;qq1<NP;qq1++)
  {canx=cano=can2o=can2x=0;
   for(qq2=0;qq2<NP;qq2++)
   {switch (a[qq1][qq2]){case X:cano=0;canx++;break;
                         case O:canx=0;cano++;break;
                         case 0:canx++;cano++;   }
   if (canx==5) return FALSE;
   if (cano==5) return FALSE;
    switch (a[qq2][qq1]){case X:can2o=0;can2x++;break;
                         case O:can2x=0;can2o++;break;
                         case 0:can2x++;can2o++; }
   if (can2x==5) return FALSE;
   if (can2o==5) return FALSE;
   }}
for(qq1=0;qq1<NP/*-4*/;qq1++)
  {canx=cano=can2x=can2o=can3x=can3o=can4x=can4o=0;
  for(qq2=0;qq2<(NP-qq1);qq2++)
   {switch (a[qq2][qq1+qq2]){case X:cano=0;canx++;break;
                             case O:canx=0;cano++;break;
                             case 0:canx++;cano++;break;}
   if (canx==5) return FALSE;
   if (cano==5) return FALSE;
    switch (a[qq2+qq1][qq2]){case X:can2o=0;can2x++;break;
                             case O:can2x=0;can2o++;break;
                             case 0:can2x++;can2o++;break;}
   if (can2x==5) return FALSE;
   if (can2o==5) return FALSE;

   switch (a[NP-1-qq1-qq2][qq2]){case X:can3o=0;can3x++;break;
                             case O:can3x=0;can3o++;break;
                             case 0:can3x++;can3o++;break;}
   if (can3x==5) return FALSE;
   if (can3o==5) return FALSE;
    switch (a[NP-1-qq2][qq1+qq2]){case X:can4o=0;can4x++;break;
                             case O:can4x=0;can4o++;break;
                             case 0:can4x++;can4o++;break;}
   if (can4x==5) return FALSE;
   if (can4o==5) return FALSE;
   }}
return TRUE;
}

void invscrl(void)
{InvalidateRect(hWnd,NULL,TRUE);
 wx=NP*wxx;
 wy=NP*wxy;
}

#pragma argsused
BOOL CALLBACK DProc(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam)
{if (msg==WM_COMMAND) EndDialog(hwndDlg,TRUE);
 return FALSE;
}
#pragma argsused
BOOL CALLBACK D2Proc(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam)
{switch(msg){
 case WM_COMMAND:EndDialog(hwndDlg,TRUE);
                 break;
 case WM_HSCROLL:switch (wParam) {
                   case SB_LINEDOWN:
                      if (wxx<70) wxx++;
                      break;
                   case SB_LINEUP:
                      if (wxx>10) wxx--;
                      break;
                      }
                invscrl();
                break;
 case WM_VSCROLL:switch (wParam) {
                   case SB_LINEDOWN:
                      if (wxy<70) wxy++;
                      break;
                   case SB_LINEUP:
                      if (wxy>10) wxy--;
                      break;
                      }
                invscrl();
                break;
        }
 return 0;
}
#pragma argsused
BOOL CALLBACK D3Proc(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam)
{if (msg==WM_COMMAND) switch (wParam)
    {case 101:EndDialog(hwndDlg,TRUE);
              break;
     case 102:if (NP>6) {NP--;invscrl();}
              break;
     case 103:if (NP<49) {NP++;invscrl();}
              break;}
 return 0;
}

void ofninit(void)
{memset(&ofn,0,sizeof(OPENFILENAME));
 memset(szFile,0,sizeof(szFile));
 ofn.lStructSize=sizeof(OPENFILENAME);
 ofn.hwndOwner=hWnd;
 ofn.lpstrFilter="Piskvork's game\0*.log\0\0";
 ofn.nFilterIndex=1;
 ofn.lpstrFile=szFile;
 ofn.nMaxFile=sizeof(szFile);
 ofn.Flags=OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
}

void RCDtoA(void)
{for(indx=0;indx<lastrec;indx++) a[rcd[indx].x][rcd[indx].y]=(indx%2==0)?X:O;
 InvalidateRect(hWnd,NULL,TRUE);
}

void Sethint(void)
{key_x=hint.x;
 key_y=hint.y;
 rv.left=hint.x*wxx;
 rv.right=(hint.x+2)*wxx;
 rv.top=hint.y*wxy;
 rv.bottom=(hint.y+1)*wxy;
 InvalidateRect(hWnd,&rv,TRUE);
 ClientToScreen(hWnd,&rv);
 SetCursorPos(rv.left+wxx/2,rv.top+wxy/2);
}

void kernel(void)
{int lx,ly; posit retp; unsigned char Me;
 Me=(WhoMoves)?X:O;
 if (indx==0) lx=ly=-1; else {lx=rcd[indx-1].x;ly=rcd[indx-1].y;}
 switch (PlayNow){
     case  0:retp.x=qq1;retp.y=qq2;
              break;
     case  1:retp.x=key_x;retp.y=key_y;
              break;
     case  2:retp=halabala(lx,ly,Me);
              break;
     case  3:retp=kuko(lx,ly,Me);
              break;
     case  4:retp=rkovac(lx,ly,Me);
              break;
     case  5:retp=bartovic(lx,ly,Me);
              break;
//     case  6:retp=ikovac(lx,ly,Me);
//              break;

             }
 if (retp.x<0||retp.x>=NP||retp.y<0||retp.y>=NP||a[retp.x][retp.y]>0) {sayerr();return;}
 //time1=GetTickCount();
 InvPis(0);
 rcd[indx].x=retp.x;
 rcd[indx].y=retp.y;
 lastrec=++indx;
 a[retp.x][retp.y]=Me;
 hint.x=-1;
 InvPis(1);
 if (ques(rcd[indx-1].x,rcd[indx-1].y,Me)) {saywin(Me);return;}
 if (drawgame()) {saydraw();return;} 
 WhoMoves=!WhoMoves;
 PlayNow=(WhoMoves)?play1-120:play2-130;
}

void DrawX(int ax,int ay,HPEN hx)
{SelectObject(mHDC,GetStockObject(LTGRAY_BRUSH));
 SelectObject(mHDC,hwire);
 Rectangle(mHDC,ax*wxx,ay*wxy,(ax+1)*wxx,(ay+1)*wxy);

 SelectObject(mHDC,hbiele);
 MoveTo(mHDC,ax*wxx+wxx/24,(ay+1)*wxy-wxy/24);
 LineTo(mHDC,ax*wxx+wxx/24,ay*wxy+wxy/24);
 LineTo(mHDC,(ax+1)*wxx-wxx/24,ay*wxy+wxy/24);

 SelectObject(mHDC,hcierne);
 MoveTo(mHDC,ax*wxx+wxx/12,(ay+1)*wxy-wxy/12);
 LineTo(mHDC,(ax+1)*wxx-wxx/12,(ay+1)*wxy-wxy/12);
 LineTo(mHDC,(ax+1)*wxx-wxx/12,ay*wxy+wxy/12);

 SelectObject(mHDC,hx);
 MoveTo(mHDC,ax*wxx+wxx/5,ay*wxy+wxy/5);
 LineTo(mHDC,(ax+1)*wxx-wxx/3,(ay+1)*wxy-wxy/3);
 MoveTo(mHDC,(ax+1)*wxx-wxx/3,ay*wxy+wxy/5);
 LineTo(mHDC,ax*wxx+wxx/5,(ay+1)*wxy-wxy/3);}

void DrawO(int ax,int ay,HPEN hx)
{SelectObject(mHDC,GetStockObject(LTGRAY_BRUSH));
 SelectObject(mHDC,hwire);
 Rectangle(mHDC,ax*wxx,ay*wxy,(ax+1)*wxx,(ay+1)*wxy);

 SelectObject(mHDC,hbiele);
 MoveTo(mHDC,ax*wxx+wxx/24,(ay+1)*wxy-wxy/24);
 LineTo(mHDC,ax*wxx+wxx/24,ay*wxy+wxy/24);
 LineTo(mHDC,(ax+1)*wxx-wxx/24,ay*wxy+wxy/24);

 SelectObject(mHDC,hcierne);
 MoveTo(mHDC,ax*wxx+wxx/12,(ay+1)*wxy-wxy/12);
 LineTo(mHDC,(ax+1)*wxx-wxx/12,(ay+1)*wxy-wxy/12);
 LineTo(mHDC,(ax+1)*wxx-wxx/12,ay*wxy+wxy/12);

 SelectObject(mHDC,hx);
 Ellipse(mHDC,ax*wxx+wxx/5,ay*wxy+wxy/5,(ax+1)*wxx-wxx/3,(ay+1)*wxy-wxy/3);}

#pragma argsused
void FAR CALLBACK MyTimerProc(HWND hwnd,UINT msg,UINT idTimer,DWORD dwTime)
{if (PlayNow>=2) kernel();}

long FAR PASCAL KalkulProc(HWND hWnd,WORD msg,WORD wParam,LONG lParam)
{
 switch(msg) {
   case WM_COMMAND:
     if ((wParam>=120)&&(wParam<=129)) {play1=wParam;
                                        setbar(TRUE);
                                        debugmod();
                                      return TRUE;}
     if ((wParam>=130)&&(wParam<=139)) {play2=wParam;
                                        setbar(TRUE);
                                        debugmod();
                                      return TRUE;}
     switch (wParam) {
       case   2:indx=0;       //<<<
                memset(a,0,50*50);
                InvalidateRect(hWnd,NULL,TRUE);
                break;
       case   4:if (indx!=0){
                a[rcd[indx-1].x][rcd[indx-1].y]=0; //<
        //        InvPis();
                Inv();
                indx--;
                InvPis(1);
                  }
                break;
       case   6:if (PlayNow<0 && indx==lastrec && !drawgame() &&
       (indx==0 || !ques(rcd[indx-1].x,rcd[indx-1].y,a[rcd[indx-1].x][rcd[indx-1].y])))
                    quitdebugmod();
                      else debugmod();
                break;
       case   5:if (indx!=lastrec){         //>
                InvPis(0);
                a[rcd[indx].x][rcd[indx].y]=(indx%2==0)?X:O;
                indx++;
                InvPis(1); }
                break;
       case   3:RCDtoA();         //>>>
                break;
       case 105:hint=kuko(1,1,(WhoMoves)?X:O);
                Sethint();
                break;
       case 106:hint=rkovac(1,1,(WhoMoves)?X:O);
                Sethint();
                break;
       case 108:if (PlayNow>0) {isplay=TRUE;debugmod();} else isplay=FALSE;
                onlywire=TRUE;
                InvalidateRect(hWnd,NULL,TRUE);
                dlgprc=(DLGPROC)MakeProcInstance(D2Proc,hInst);
                DialogBox(hInst,"DIALOG_2",hWnd,dlgprc);
                FreeProcInstance((FARPROC)dlgprc);
                onlywire=FALSE;
                if (isplay) quitdebugmod();
                InvalidateRect(hWnd,NULL,TRUE);
                break;
       case 109:if (PlayNow>0) {isplay=TRUE;debugmod();} else isplay=FALSE;
                //choosecolor
                if (isplay) quitdebugmod();
                break;
       case 110://Wireframe
                wire=!wire;
                CheckMenuItem(hm,110,(wire)?MF_CHECKED:MF_UNCHECKED);
                DrawMenuBar(hWnd);
                InvalidateRect(hWnd,NULL,TRUE);
                break;
  /*     case 111://BitBlt
                bblt=!bblt;
                CheckMenuItem(hm,111,(bblt)?MF_CHECKED:MF_UNCHECKED);
                DrawMenuBar(hWnd);
                InvalidateRect(hWnd,NULL,TRUE);
                break;
       case 112://Only last
                onlylast=!onlylast;
                CheckMenuItem(hm,112,(onlylast)?MF_CHECKED:MF_UNCHECKED);
                DrawMenuBar(hWnd);
                if (!onlylast) InvalidateRect(hWnd,NULL,TRUE);
                break;
  */     case 100:lastrec=indx=0;
                onlywire=TRUE;
                InvalidateRect(hWnd,NULL,TRUE);
                debugmod();
                dlgprc=(DLGPROC)MakeProcInstance(D3Proc,hInst);
                DialogBox(hInst,"DIALOG_3",hWnd,dlgprc);
                FreeProcInstance((FARPROC)dlgprc);
                onlywire=FALSE;
                NGame();
                break;
       case 101:if (PlayNow>0) {isplay=TRUE;debugmod();} else isplay=FALSE;
                ofninit();
	        if (GetOpenFileName(&ofn)) {
                 file1=fopen((char *)ofn.lpstrFile,"rb");
                 indx=0;
                 while (!feof(file1))
                  {fscanf(file1,"%d%d%d%d",&(rcd[indx].x),&(rcd[indx].y),&qq1,&qq2);
                   indx++;} 
                  fclose(file1);
                  lastrec=--indx;
                  memset(a,0,50*50);
                  if (rcd[indx].x==-10) {NP=rcd[indx].y;
                                         play1=qq1;play2=qq2;
                                         wx=wxx*NP;wy=wxy*NP;}
                  RCDtoA();
                  debugmod();
                 } else if (isplay) quitdebugmod();
               break;
       case 102:if (PlayNow>0) {isplay=TRUE;debugmod();} else isplay=FALSE;
                ofninit();
	        if (GetSaveFileName(&ofn)) {
                 file1=fopen((char *)ofn.lpstrFile,"wb");
                 for(qq1=0;qq1<lastrec;qq1++) fprintf(file1,"%d %d %d %d\n",rcd[qq1].x,rcd[qq1].y,qq1,qq2);
                 fprintf(file1,"%d %d %d %d",-10,NP,play1,play2);
                 fclose(file1);
                 }
               if (isplay) quitdebugmod();
               break;
       case 104:TheEnd();        //Exit
               break;
       case 115:debugmod();      //Help/Index
                WinHelp(hWnd,"piskvork.hlp",HELP_CONTENTS,0);
                break;           //Help/About
       case 116:if (PlayNow>0) {isplay=TRUE;debugmod();} else isplay=FALSE;
                dlgprc=(DLGPROC)MakeProcInstance(DProc,hInst);
                DialogBox(hInst,"DIALOG_1",hWnd,dlgprc);
                FreeProcInstance((FARPROC)dlgprc);
                if (isplay) quitdebugmod();
                break;
       }
          return TRUE;
   case WM_KEYDOWN:
        rv.left=key_x*wxx-2;
        rv.top=key_y*wxy-2;
        rv.right=(key_x+1)*wxx+2;
        rv.bottom=(key_y+1)*wxy+2;
        InvalidateRect(hWnd,&rv,TRUE);
        if (PlayNow==1)
        switch (wParam) {case VK_LEFT :if (key_x>0) key_x--;break;
                         case VK_RIGHT:if (key_x<NP-1) key_x++;break;
                         case VK_UP   :if (key_y>0) key_y--;break;
                         case VK_DOWN :if (key_y<NP-1) key_y++;break;
                         case VK_RETURN:if (a[key_x][key_y]==0) kernel();
                        }
        rv.left=key_x*wxx-2;
        rv.top=key_y*wxy-2;
        rv.right=(key_x+1)*wxx+2;
        rv.bottom=(key_y+1)*wxy+2;
        InvalidateRect(hWnd,&rv,TRUE);
        return TRUE;
   case WM_LBUTTONDOWN:
	  cx=LOWORD(lParam);
	  cy=HIWORD(lParam);
          qq1=cx/wxx;
          qq2=cy/wxy;
          if ((PlayNow==0)&&(qq1<NP)&&(qq2<NP)&&(za3(qq1,qq2)==0)) kernel();
          return TRUE;
   case WM_PAINT:
	  mHDC=BeginPaint(hWnd,&ps);
          hwire=CreatePen(PS_SOLID,1,RGB(100,200,200));
          hbiele=CreatePen(PS_SOLID,(wxx+wxy)/24,RGB(255,255,255));
          hcervene=CreatePen(PS_SOLID,(wxx+wxy)/12,RGB(255,0,0));
          hmodre=CreatePen(PS_SOLID,(wxx+wxy)/12,RGB(0,0,255));
          hcierne=CreatePen(PS_SOLID,(wxx+wxy)/12,RGB(0,0,0));
          hold=SelectObject(mHDC,hwire);
          if (wire||onlywire) {for(cx=0;cx<=NP;cx++) {MoveTo(mHDC,cx*wxx,0);LineTo(mHDC,cx*wxx,wy);}
	             for(cx=0;cx<=NP;cx++) {MoveTo(mHDC,0,cx*wxy);LineTo(mHDC,wx,cx*wxy);}
                    }
          if (onlywire) goto lala;
          if (indx>0) {
                       if (a[rcd[indx-1].x][rcd[indx-1].y]==X) DrawX(rcd[indx-1].x,rcd[indx-1].y,hcierne);
                       if (a[rcd[indx-1].x][rcd[indx-1].y]==O) DrawO(rcd[indx-1].x,rcd[indx-1].y,hcierne);
                      } else goto lala;
           if (indx==1) goto lala;
           cx=indx-1;
           pi1=pi2=FALSE;
     do   {cx--;
           qq1=rcd[cx].x;qq2=rcd[cx].y;
           if (cx%2==0) {kx1=qq1*wxx;
                         kx2=qq2*wxy;
                         DrawX(qq1,qq2,hmodre);
                         pi1=TRUE;}
                  else  {ko1=qq1*wxx;
                         ko2=qq2*wxy;
                         DrawO(qq1,qq2,hcervene);
                         pi2=TRUE;}
           } while  (cx>0);//&&!(bblt&&pi1&&pi2)&&!(onlylast&&(pi1||pi2)) );
        // if (onlylast) goto lala;
        /* while (cx>0){cx--;
                      qq1=rcd[cx].x;qq2=rcd[cx].y;
                      if (cx%2==0) BitBlt(mHDC,qq1*wxx,qq2*wxy,wxx,wxy,mHDC,kx1,kx2,SRCCOPY);
                             else  BitBlt(mHDC,qq1*wxx,qq2*wxy,wxx,wxy,mHDC,ko1,ko2,SRCCOPY);
                     }*/
lala:if (PlayNow==1) {SelectObject(mHDC,hcierne);
                      MoveTo(mHDC,key_x*wxx,key_y*wxy);
                      LineTo(mHDC,key_x*wxx,(key_y+1)*wxy);
                      LineTo(mHDC,(key_x+1)*wxx,(key_y+1)*wxy);
                      LineTo(mHDC,(key_x+1)*wxx,key_y*wxy);
                      LineTo(mHDC,key_x*wxx,key_y*wxy);}
     SelectObject(mHDC,hold);
     DeleteObject(hcierne);
     DeleteObject(hmodre);
     DeleteObject(hcervene);
     DeleteObject(hbiele);
     DeleteObject(hwire);
     EndPaint(hWnd,&ps);
	  break;
   case WM_DESTROY:TheEnd();
       break;
   default:
       return(DefWindowProc(hWnd,msg,wParam,lParam));
       }
       return 0L;
}

#pragma argsused
int PASCAL WinMain(HANDLE hInstance,HANDLE hPrevInstance,LPSTR lpszCmdLine,int nCmdShow)
{  MSG msg;
   WORD cleft,ctop,cright,cbottom;
   if(!hPrevInstance) {
       wndClass.lpszClassName="PISK";
       wndClass.hInstance=hInstance;
       wndClass.lpfnWndProc=(WNDPROC)KalkulProc;
       wndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
       wndClass.hIcon=LoadIcon(hInstance,"ICON_1");
       wndClass.lpszMenuName="KAL_MENU";
       wndClass.hbrBackground=GetStockObject(DKGRAY_BRUSH);
//       wndClass.style=CS_DBLCLKS|CS_BYTEALIGNWINDOW|CS_SAVEBITS;
//       wndClass.cbClsExtra=0;
//       wndClass.cbWndExtra=0;
       if(!RegisterClass(&wndClass)) return FALSE;
      }
      n=(int *)malloc(5000);
      if (n==NULL) return FALSE;
      rcd=(rec*)malloc(50*50*8);
      if (rcd==NULL) return FALSE;
      NP=GetPrivateProfileInt("Size","NP",19,"piskvork.ini");
      wxx=GetPrivateProfileInt("Size","wxx",28,"piskvork.ini");
      wxy=GetPrivateProfileInt("Size","wxy",22,"piskvork.ini");
      cleft=GetPrivateProfileInt("Size","left",5,"piskvork.ini");
      ctop=GetPrivateProfileInt("Size","top",5,"piskvork.ini");
      cright=GetPrivateProfileInt("Size","width",545,"piskvork.ini");
      cbottom=GetPrivateProfileInt("Size","height",470,"piskvork.ini");

      wire=GetPrivateProfileInt("Options","wire",TRUE,"piskvork.ini");
//      bblt=GetPrivateProfileInt("Options","bblt",TRUE,"piskvork.ini");
//      onlylast=GetPrivateProfileInt("Options","onlylast",FALSE,"piskvork.ini");
      hWnd=CreateWindow("PISK","",WS_OVERLAPPEDWINDOW|WS_VISIBLE,
           cleft,ctop,cright,cbottom,NULL,NULL,hInstance,NULL);
      lpfnMyTimerProc=MakeProcInstance((FARPROC)MyTimerProc,hInstance);
      if (!SetTimer(hWnd,1,10, lpfnMyTimerProc)) return FALSE;
      randomize();
      hInst=hInstance;
      hm=GetMenu(hWnd);
//      CheckMenuItem(hm,111,(bblt)?MF_CHECKED:MF_UNCHECKED);
//      CheckMenuItem(hm,112,(onlylast)?MF_CHECKED:MF_UNCHECKED);
      CheckMenuItem(hm,110,(wire)?MF_CHECKED:MF_UNCHECKED);
      DrawMenuBar(hWnd);
      setbar(FALSE);
      NGame();
      while(GetMessage(&msg,0,0,0))
       {if (IsDialogMessage(NULL/*hDlg*/,&msg)) continue;
	TranslateMessage(&msg);
	DispatchMessage(&msg);}
   return 0;
}
